<?php
/**
* @version 1.0.0
* @package RSSearch! 1.0.0
* @copyright (C) 2011 www.rsjoomla.com
* @license GPL, http://www.gnu.org/licenses/gpl-2.0.html
*/
defined( '_JEXEC' ) or die( 'Restricted access' );
jimport('joomla.plugin.plugin');
jimport('joomla.filesystem.file');
jimport('joomla.filesystem.folder');

class plgRSSearchRSFiles extends JPlugin
{
	public function __construct( &$subject, $config ) {
		parent::__construct( $subject, $config );
	}

	public function getResults(&$results, $search, $params) {
	    
		if (!file_exists(JPATH_SITE.'/components/com_rsfiles/helpers/rsfiles.php'))
			return false;
		
		require_once JPATH_SITE.'/components/com_rsfiles/helpers/rsfiles.php';
		
		$db 		= JFactory::getDbo();
		$query		= $db->getQuery(true);
	    $orderby 	= $this->params->get('orderby','FileName');
	    $asc_desc 	= $this->params->get('asc_desc','ASC');
	    $itemId 	= $this->params->get('Itemid','');
	    $itemId 	= (empty($itemId) ? '' : '&Itemid='.$itemId);
		$ds			= rsfilesHelper::ds();
		$files 		= array();
		
		JFactory::getLanguage()->load('plg_rssearch_rsfiles',JPATH_ADMINISTRATOR);

		require_once JPATH_ADMINISTRATOR . '/components/com_search/helpers/search.php';

		if (!in_array($orderby,array('FileName','hits','DateCreated')))
			$orderby = 'FileName';
		
		$db->setQuery("SELECT ConfigValue FROM #__rsfiles_config WHERE ConfigName = 'download_folder'");
		$download_folder = $db->loadResult();
		
		if (empty($download_folder) || !is_dir(realpath($download_folder)))
			return false;
		
		$query->clear()
			->select($db->qn('IdFile'))->select($db->qn('FilePath'))
			->select($db->qn('FileName'))->select($db->qn('FileDescription'))
			->select($db->qn('FileType'))->select($db->qn('DateAdded'))
			->select($db->qn('published'))
			->from($db->qn('#__rsfiles_files'))
			->where($db->qn('published').' = 1')
			->where($db->qn('briefcase').' = 0')
			->order($db->qn($orderby).' '.$db->escape($asc_desc));
		
		$text = $db->q('%' . $db->escape($search, true) . '%', false);
		$query->where('('.$db->qn('FileName').' LIKE '.$text.' OR '.$db->qn('FileDescription').' LIKE '.$text.' OR '.$db->qn('FilePath').' LIKE '.$text.')');
		
		$db->setQuery($query);
		if ($files = $db->loadObjectList()) {
			foreach ($files as $file) {
				if (!searchHelper::checkNoHTML($file, $search, array('FilePath', 'FileName', 'FileDescription')) ) continue;
				
				$tmp		= new stdClass();
				
				$fullpath	= $download_folder.$ds.$file->FilePath;
				$type		= $file->FileType ? 'external' : (is_dir($fullpath) ? 'folder' : 'file');
				
				$fullpath	= $file->FileType ? $file->IdFile : $file->FilePath;
				$link		= ($type == 'folder') ? 'index.php?option=com_rsfiles&folder='.$fullpath : 'index.php?option=com_rsfiles&layout=download&path='.$fullpath;
				
				$tmp->title = empty($file->FileName) ? rsfilesHelper::getName($file->FilePath) : $file->FileName;
				$tmp->link	= JRoute::_($link.$itemId);
				$tmp->text 	= !empty($thefile->FileDescription) ? $thefile->FileDescription : '';
				$tmp->type 	= JText::_('RSF_RSFILES_XML_FILE');
				$results[]	= $tmp;
			}
		}
		
		
		return true;
	}
}